diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/test/bit-serializer-test.cc ns-3.34/src/network/test/bit-serializer-test.cc
--- ns-3.33/src/network/test/bit-serializer-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/network/test/bit-serializer-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,148 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+#include <cstdarg>
+#include <iostream>
+#include <sstream>
+#include "ns3/test.h"
+#include "ns3/bit-serializer.h"
+#include "ns3/bit-deserializer.h"
+
+using namespace ns3;
+
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Bit serialization test
+ */
+class BitSerializerTest : public TestCase
+{
+public:
+  virtual void DoRun (void);
+  BitSerializerTest ();
+};
+
+BitSerializerTest::BitSerializerTest ()
+  : TestCase ("BitSerializer")
+{}
+
+void BitSerializerTest::DoRun ()
+{
+  BitSerializer testBitSerializer1;
+
+  testBitSerializer1.PushBits (0x55, 7);
+  testBitSerializer1.PushBits (0x7, 3);
+  testBitSerializer1.PushBits (0x0, 2);
+
+  std::vector<uint8_t> result = testBitSerializer1.GetBytes ();
+  NS_TEST_EXPECT_MSG_EQ ((result[0] == 0xab) && (result[1] == 0xc0), true,
+                         "Incorrect serialization " << std::hex << +result[0] << +result[1] << " instead of " << 0xab << " " << 0xc0 << std::dec);
+
+  BitSerializer testBitSerializer2;
+
+  testBitSerializer2.PushBits (0x55, 7);
+  testBitSerializer2.PushBits (0x7, 3);
+  testBitSerializer2.PushBits (0x0, 2);
+
+  testBitSerializer2.InsertPaddingAtEnd (false);
+
+  result = testBitSerializer2.GetBytes ();
+  NS_TEST_EXPECT_MSG_EQ ((result[0] == 0x0a) && (result[1] == 0xbc), true,
+                         "Incorrect serialization " << std::hex << +result[0] << +result[1] << " instead of " << 0x0a << " " << 0xbc << std::dec);
+}
+
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Bit deserialization test
+ */
+class BitDeserializerTest : public TestCase
+{
+public:
+  virtual void DoRun (void);
+  BitDeserializerTest ();
+};
+
+BitDeserializerTest::BitDeserializerTest ()
+  : TestCase ("BitDeserializer")
+{}
+
+void BitDeserializerTest::DoRun ()
+{
+  uint16_t nibble1;
+  uint16_t nibble2;
+  uint16_t nibble3;
+  bool result;
+
+  BitDeserializer testBitDeserializer1;
+  uint8_t test1[2];
+  test1[0] = 0xab;
+  test1[1] = 0xc0;
+
+  testBitDeserializer1.PushBytes (test1, 2);
+  nibble1 = testBitDeserializer1.GetBits (7);
+  nibble2 = testBitDeserializer1.GetBits (3);
+  nibble3 = testBitDeserializer1.GetBits (2);
+  result = (nibble1 == 0x55) && (nibble2 == 0x7) && (nibble3 == 0x0);
+
+  NS_TEST_EXPECT_MSG_EQ (result, true,
+                         "Incorrect deserialization " << std::hex << nibble1 << " " << nibble2 << " " << nibble3 <<
+                         " << instead of " << " " << 0x55 << " " << 0x7 << " " << 0x0 << std::dec);
+
+  BitDeserializer testBitDeserializer2;
+  std::vector<uint8_t> test2;
+  test2.push_back (0xab);
+  test2.push_back (0xc0);
+
+  testBitDeserializer2.PushBytes (test2);
+  nibble1 = testBitDeserializer2.GetBits (7);
+  nibble2 = testBitDeserializer2.GetBits (3);
+  nibble3 = testBitDeserializer2.GetBits (2);
+
+  result = (nibble1 == 0x55) && (nibble2 == 0x7) && (nibble3 == 0x0);
+
+  NS_TEST_EXPECT_MSG_EQ (result, true,
+                         "Incorrect deserialization " << std::hex << nibble1 << " " << nibble2 << " " << nibble3 <<
+                         " << instead of " << " " << 0x55 << " " << 0x7 << " " << 0x0 << std::dec);
+
+}
+
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Packet Metadata TestSuite
+ */
+class BitSerializerTestSuite : public TestSuite
+{
+public:
+  BitSerializerTestSuite ();
+};
+
+
+BitSerializerTestSuite::BitSerializerTestSuite ()
+  : TestSuite ("bit-serializer", UNIT)
+{
+  AddTestCase (new BitSerializerTest, TestCase::QUICK);
+  AddTestCase (new BitDeserializerTest, TestCase::QUICK);
+}
+
+static BitSerializerTestSuite g_bitSerializerTest; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/test/packet-test-suite.cc ns-3.34/src/network/test/packet-test-suite.cc
--- ns-3.33/src/network/test/packet-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/test/packet-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -449,6 +449,14 @@
    * \param ... The variable arguments
    */
   void DoCheck (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...);
+  /**
+   * Checks the packet and its data
+   * \param p The packet
+   * \param file The file name
+   * \param line The line number
+   * \param n The number of variable arguments
+   * \param ... The variable arguments
+   */
   void DoCheckData (Ptr<const Packet> p, const char *file, int line, uint32_t n, ...);
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/test/test-data-rate.cc ns-3.34/src/network/test/test-data-rate.cc
--- ns-3.33/src/network/test/test-data-rate.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/test/test-data-rate.cc	2021-07-14 10:31:07.000000000 -0700
@@ -25,12 +25,37 @@
 
 using namespace ns3;
 
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Test Data rate
+ *
+ */
 class DataRateTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param name test name
+   */
   DataRateTestCase (std::string name);
   virtual ~DataRateTestCase ();
+
+  /**
+   * Checks if two time values are equal
+   * \param t1 first time to check
+   * \param t2 second time to check
+   * \param msg check output message
+   */
   void CheckTimesEqual (Time t1, Time t2, const std::string msg);
+  /**
+   * Checks if two data rates values are equal
+   * \param d1 first data rate to check
+   * \param d2 second data rate to check
+   * \param msg check output message
+   */
+  void CheckDataRateEqual (DataRate d1, DataRate d2, const std::string msg);
 
 protected:
   virtual void DoRun (void) = 0;
@@ -52,10 +77,31 @@
   NS_TEST_EXPECT_MSG_EQ (actualFemtos, correctFemtos, msg);
 }
 
+void
+DataRateTestCase::CheckDataRateEqual (DataRate d1, DataRate d2, const std::string msg)
+{
+  NS_TEST_EXPECT_MSG_EQ (d1, d2, msg);
+}
+
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Test Data rate
+ *
+ */
 class DataRateTestCase1 : public DataRateTestCase
 {
 public:
   DataRateTestCase1 ();
+
+  /**
+   * Checks that a given number of bits, at a specified datarate, are
+   * corresponding to a given time
+   * \param rate the DataRate
+   * \param nBits number of bits
+   * \param correctTime expected time
+   */
   void SingleTest (std::string rate, size_t nBits, Time correctTime);
 
 private:
@@ -107,6 +153,124 @@
     }
 }
 
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief Test Data rate
+ *
+ */
+class DataRateTestCase2 : public DataRateTestCase
+{
+public:
+  DataRateTestCase2 (); 
+  /**
+   * Checks data rate addition
+   * \param rate1 first data rate
+   * \param rate2 second data rate
+   * \param rate3 third data rate (first plus second)
+   */
+  void AdditionTest (std::string rate1, std::string rate2, std::string rate3);
+  /**
+   * Checks data rate subtraction
+   * \param rate1 first data rate
+   * \param rate2 second data rate
+   * \param rate3 third data rate (first minus second)
+   */
+  void SubtractionTest (std::string rate1, std::string rate2, std::string rate3);
+  /**
+   * Checks data rate integer multiplication
+   * \param rate1 first data rate
+   * \param factor multiplication factor
+   * \param rate2 second data rate  (first multiplied by factor)
+   */
+  void MultiplicationIntTest (std::string rate1, uint64_t factor, std::string rate2);
+  /**
+   * Checks data rate floating point multiplication
+   * \param rate1 first data rate
+   * \param factor multiplication factor
+   * \param rate2 second data rate  (first multiplied by factor)
+   */
+  void MultiplicationDoubleTest (std::string rate1, double factor, std::string rate2);
+
+private:
+  virtual void DoRun (void); 
+};
+
+DataRateTestCase2::DataRateTestCase2 ()
+    : DataRateTestCase ("Test arithmatic on DateRate")
+{
+}
+
+void
+DataRateTestCase2::AdditionTest (std::string rate1, std::string rate2, std::string rate3)
+{
+  DataRate dr1 (rate1);
+  DataRate dr2 (rate2);
+  DataRate dr3 (rate3);
+
+  CheckDataRateEqual(dr1 + dr2, dr3, "DataRate Addition returned incorrect value");
+  
+  dr1 += dr2;
+  CheckDataRateEqual(dr1, dr3, "DataRate Addition returned incorrect value");
+}
+
+void
+DataRateTestCase2::SubtractionTest (std::string rate1, std::string rate2, std::string rate3)
+{
+  DataRate dr1 (rate1);
+  DataRate dr2 (rate2);
+  DataRate dr3 (rate3);
+
+  CheckDataRateEqual(dr1 - dr2, dr3, "DataRate Subtraction returned incorrect value");
+
+  dr1 -= dr2;
+  CheckDataRateEqual(dr1, dr3, "DataRate Subtraction returned incorrect value");
+}
+
+void
+DataRateTestCase2::MultiplicationIntTest (std::string rate1, uint64_t factor, std::string rate2)
+{
+  DataRate dr1 (rate1);
+  DataRate dr2 (rate2);
+
+  CheckDataRateEqual(dr1 * factor, dr2, "DataRate Multiplication with Int returned incorrect value");
+
+  dr1 *= factor;
+  CheckDataRateEqual(dr1, dr2, "DataRate Multiplication with Int returned incorrect value");
+}
+
+void
+DataRateTestCase2::MultiplicationDoubleTest (std::string rate1, double factor, std::string rate2)
+{
+  DataRate dr1 (rate1);
+  DataRate dr2 (rate2);
+
+  CheckDataRateEqual(dr1 * factor, dr2, "DataRate Multiplication with Double returned incorrect value");
+
+  dr1 *= factor;
+  CheckDataRateEqual(dr1, dr2, "DataRate Multiplication with Double returned incorrect value");
+}
+
+void
+DataRateTestCase2::DoRun ()
+{
+  AdditionTest("1Mb/s", "3Mb/s", "4Mb/s");
+  AdditionTest("1Gb/s", "1b/s", "1000000001b/s");
+  SubtractionTest("1Mb/s", "1b/s", "999999b/s");
+  SubtractionTest("2Gb/s", "2Gb/s", "0Gb/s");
+  MultiplicationIntTest("5Gb/s", 2, "10Gb/s");
+  MultiplicationIntTest("4Mb/s", 1000, "4Gb/s");
+  MultiplicationDoubleTest("1Gb/s", 0.001, "1Mb/s");
+  MultiplicationDoubleTest("6Gb/s", 1.0/7.0, "857142857.14b/s");
+}
+
+/**
+ * \ingroup network-test
+ * \ingroup tests
+ *
+ * \brief DataRate TestSuite
+ */
 class DataRateTestSuite : public TestSuite
 {
 public:
@@ -116,7 +280,7 @@
 DataRateTestSuite::DataRateTestSuite () : TestSuite ("data-rate", UNIT)
 {
   AddTestCase (new DataRateTestCase1 (), TestCase::QUICK);
+  AddTestCase (new DataRateTestCase2 (), TestCase::QUICK);
 }
 
-// Do not forget to allocate an instance of this TestSuite
-static DataRateTestSuite sDataRateTestSuite;
+static DataRateTestSuite sDataRateTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/bit-deserializer.cc ns-3.34/src/network/utils/bit-deserializer.cc
--- ns-3.33/src/network/utils/bit-deserializer.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/network/utils/bit-deserializer.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,98 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include <iostream>
+#include "bit-deserializer.h"
+#include "ns3/log.h"
+#include "ns3/abort.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("BitDeserializer");
+
+BitDeserializer::BitDeserializer ()
+{
+  NS_LOG_FUNCTION (this);
+  m_deserializing = false;
+}
+
+void BitDeserializer::PushBytes (std::vector<uint8_t> bytes)
+{
+  NS_LOG_FUNCTION (this << bytes);
+  NS_ABORT_MSG_IF (m_deserializing, "Can't add bytes after deserialization started");
+  m_bytesBlob.insert (m_bytesBlob.end (), bytes.begin (), bytes.end ());
+}
+
+void BitDeserializer::PushBytes (uint8_t* bytes, uint32_t size)
+{
+  NS_LOG_FUNCTION (this << bytes << size);
+  NS_ABORT_MSG_IF (m_deserializing, "Can't add bytes after deserialization started");
+  for (uint32_t index = 0; index < size; index++)
+    {
+      m_bytesBlob.push_back (bytes[index]);
+    }
+}
+
+void BitDeserializer::PushByte (uint8_t byte)
+{
+  NS_LOG_FUNCTION (this << +byte);
+  NS_ABORT_MSG_IF (m_deserializing, "Can't add bytes after deserialization started");
+  m_bytesBlob.push_back (byte);
+}
+
+uint64_t BitDeserializer::GetBits (uint8_t size)
+{
+  NS_LOG_FUNCTION (this << +size);
+  uint8_t result = 0;
+  PrepareDeserialization ();
+
+  NS_ABORT_MSG_IF (size > 64, "Number of requested bits exceeds 64");
+  NS_ABORT_MSG_IF (size > m_blob.size (), "Number of requested bits exceeds blob size");
+
+  for (uint8_t i = 0; i < size; i++)
+    {
+      result <<= 1;
+      result |= m_blob.front ();
+      m_blob.pop_front ();
+    }
+  return result;
+}
+
+void BitDeserializer::PrepareDeserialization ()
+{
+  NS_LOG_FUNCTION (this);
+  if (m_deserializing == false)
+    {
+      m_deserializing = true;
+      for (auto index = m_bytesBlob.begin (); index != m_bytesBlob.end (); index++)
+        {
+          m_blob.push_back (*index & 0x80);
+          m_blob.push_back (*index & 0x40);
+          m_blob.push_back (*index & 0x20);
+          m_blob.push_back (*index & 0x10);
+          m_blob.push_back (*index & 0x8);
+          m_blob.push_back (*index & 0x4);
+          m_blob.push_back (*index & 0x2);
+          m_blob.push_back (*index & 0x1);
+        }
+    }
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/bit-deserializer.h ns-3.34/src/network/utils/bit-deserializer.h
--- ns-3.33/src/network/utils/bit-deserializer.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/network/utils/bit-deserializer.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,90 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#ifndef BITDESERIALIZER_H_
+#define BITDESERIALIZER_H_
+
+#include <vector>
+#include <deque>
+
+namespace ns3 {
+
+/**
+ * \ingroup packet
+ *
+ * \brief Bit deserializer. See also \sa ns3::BitSerializer
+ *
+ * This class helps converting a variable number, variable sized
+ * number of bit-boundary fields stored as byte array representation
+ * and extract the original bit-fields.
+ *
+ * Note that once the Deserialization starts, it's not anymore
+ * possible to add more data to the byte blob to deserialize.
+ */
+
+class BitDeserializer
+{
+public:
+  BitDeserializer ();
+
+  /**
+   * Pushes some bytes into the blob to be deserialized.
+   * \param bytes The bytes to add.
+   */
+  void PushBytes (std::vector<uint8_t> bytes);
+
+  /**
+   * Pushes some bytes into the blob to be deserialized.
+   * \param bytes The bytes to add.
+   * \param size The length of the array.
+   */
+  void PushBytes (uint8_t* bytes, uint32_t size);
+
+  /**
+   * Pushes one byte into the blob to be deserialized.
+   * \param byte The byte to add.
+   */
+  void PushByte (uint8_t byte);
+
+  /**
+   * Pops a given number of bits from the blob front. In other terms,
+   * 'size' bits are shifted from the contents of the byte blob
+   * onto the return value.
+   *
+   * The maximum number of bits to be deserialized in one single call is 64.
+   *
+   * \param size The number of bits to pop.
+   */
+  uint64_t GetBits (uint8_t size);
+
+private:
+  /**
+   * Prepare the byte array to the deserialization.
+   */
+  void PrepareDeserialization ();
+
+  std::deque<bool> m_blob; //!< Blob of bits ready to be deserialized.
+  std::vector<uint8_t> m_bytesBlob;  //!< Blob of bytes to be deserialized.
+  bool m_deserializing; //!< True if the deserialization did start already.
+};
+
+} // namespace ns3
+
+#endif /* BITDESERIALIZER_H_ */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/bit-serializer.cc ns-3.34/src/network/utils/bit-serializer.cc
--- ns-3.33/src/network/utils/bit-serializer.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/network/utils/bit-serializer.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,130 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include <iostream>
+#include "bit-serializer.h"
+#include "ns3/log.h"
+#include "ns3/assert.h"
+#include "ns3/abort.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("BitSerializer");
+
+BitSerializer::BitSerializer ()
+{
+  NS_LOG_FUNCTION (this);
+  m_padAtEnd = true;
+}
+
+void BitSerializer::InsertPaddingAtEnd (bool padAtEnd)
+{
+  NS_LOG_FUNCTION (this);
+  m_padAtEnd = padAtEnd;
+}
+
+void BitSerializer::PadAtStart ()
+{
+  NS_LOG_FUNCTION (this);
+
+  uint8_t padding = 8 - (m_blob.size () % 8);
+
+  m_blob.insert (m_blob.begin (), padding, false);
+}
+
+void BitSerializer::PadAtEnd ()
+{
+  uint8_t padding = 8 - (m_blob.size () % 8);
+
+  m_blob.insert (m_blob.end (), padding, false);
+}
+
+void BitSerializer::PushBits (uint64_t value, uint8_t significantBits)
+{
+  NS_LOG_FUNCTION (this << value << +significantBits);
+
+  uint64_t mask = 1;
+  mask <<= significantBits - 1;
+
+  for (uint8_t i = 0; i < significantBits; i++)
+    {
+      if (value & mask)
+        {
+          m_blob.push_back (true);
+        }
+      else
+        {
+          m_blob.push_back (false);
+        }
+      mask >>= 1;
+    }
+}
+
+std::vector<uint8_t> BitSerializer::GetBytes ()
+{
+  NS_LOG_FUNCTION (this);
+
+  std::vector<uint8_t> result;
+
+  m_padAtEnd ? PadAtEnd () : PadAtStart ();
+
+  for (auto it = m_blob.begin (); it != m_blob.end ();)
+    {
+      uint8_t tmp = 0;
+      for (uint8_t i = 0; i < 8; ++i)
+        {
+          tmp <<= 1;
+          tmp |= (*it & 1);
+          it++;
+        }
+      result.push_back (tmp);
+    }
+  m_blob.clear ();
+  return result;
+}
+
+uint8_t BitSerializer::GetBytes (uint8_t *buffer, uint32_t size)
+{
+  NS_LOG_FUNCTION (this << buffer << size);
+
+  uint8_t resultLen = 0;
+
+  m_padAtEnd ? PadAtEnd () : PadAtStart ();
+
+  NS_ABORT_MSG_IF (m_blob.size () <= 8 * size, "Target buffer is too short, " << m_blob.size () / 8 << " bytes needed" );
+
+  for (auto it = m_blob.begin (); it != m_blob.end ();)
+    {
+      uint8_t tmp = 0;
+      for (uint8_t i = 0; i < 8; ++i)
+        {
+          tmp <<= 1;
+          tmp |= (*it & 1);
+          it++;
+        }
+      buffer[resultLen] = tmp;
+      resultLen++;
+
+    }
+  m_blob.clear ();
+  return resultLen;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/bit-serializer.h ns-3.34/src/network/utils/bit-serializer.h
--- ns-3.33/src/network/utils/bit-serializer.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/network/utils/bit-serializer.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,117 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#ifndef BITSERIALIZER_H_
+#define BITSERIALIZER_H_
+
+#include <vector>
+
+namespace ns3 {
+
+/**
+ * \ingroup packet
+ *
+ * \brief Bit serializer. See also \sa ns3::BitDeserializer
+ *
+ * This class helps converting a variable number, variable sized
+ * number of bit-boundary fields to its final byte array representation.
+ *
+ * The typical use-case is:
+ * \verbatim
+   aaa: A field
+   bbb: B field
+   ccc: C field
+   ddd: D field
+   000: padding
+
+   |aaaa abbb bbcc cdd0|
+ \endverbatim
+ *
+ *
+ * Padding can be automatically added at the end or at the start
+ * of the byte blob to reach a multiple of 8 bits.
+ * By default the padding is added at the end of the byte blob.
+ *
+ * This class should be used in two cases:
+ *   - When the number of fields is large.
+ *   - When the number of fields is variable.
+ * In the other cases it's more convenient to use a simple bitmask.
+ */
+
+class BitSerializer
+{
+public:
+  BitSerializer ();
+
+  /**
+   * Toggles the padding insertion policy.
+   * \param padAtEnd true if the padding have to be inserted at the end of the bit blob.
+   */
+  void InsertPaddingAtEnd (bool padAtEnd);
+
+  /**
+   * Pushes a number of bits in the blob.
+   * \param value the bits to be inserted.
+   * \param significantBits Number of bits to insert.
+   */
+  void PushBits (uint64_t value, uint8_t significantBits);
+
+  /**
+   * Get the bytes representation of the blob.
+   * Note that this operation  \b automatically add the
+   * needed padding at the end (or start) of the blob.
+   *
+   * \warning {This operation clears the stored data.}
+   *
+   * \returns The byte representation of the blob.
+   */
+  std::vector<uint8_t> GetBytes ();
+
+  /**
+   * Get the bytes representation of the blob.
+   * Note that this operation  \b automatically add the
+   * needed padding at the end (or start) of the blob.
+   *
+   * \warning {This operation clears the stored data.}
+   *
+   * \param [out] buffer The buffer where to store the return data.
+   * \param [in] size The size of the buffer.
+   * \returns The number of bytes actually used in the buffer.
+   */
+  uint8_t GetBytes (uint8_t *buffer, uint32_t size);
+
+private:
+  /**
+   * Add the padding at the start of the blob.
+   */
+  void PadAtStart ();
+
+  /**
+   * Add the padding at the end of the blob.
+   */
+  void PadAtEnd ();
+
+  std::vector<bool> m_blob; //!< Blob of serialized bits.
+  bool m_padAtEnd; //!< True if the padding must be added at the end of the blob.
+};
+
+} // namespace ns3
+
+#endif /* BITSERIALIZER_H_ */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/data-rate.cc ns-3.34/src/network/utils/data-rate.cc
--- ns-3.33/src/network/utils/data-rate.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/utils/data-rate.cc	2021-07-14 10:31:07.000000000 -0700
@@ -196,6 +196,52 @@
   NS_LOG_FUNCTION (this << bps);
 }
 
+DataRate DataRate::operator + (DataRate rhs)
+{
+  return DataRate(m_bps + rhs.m_bps);
+}
+
+DataRate& DataRate::operator += (DataRate rhs)
+{
+  m_bps += rhs.m_bps;
+  return *this;
+}
+
+DataRate DataRate::operator - (DataRate rhs)
+{
+  NS_ASSERT_MSG(m_bps >= rhs.m_bps, "Data Rate cannot be negative.");
+  return DataRate(m_bps - rhs.m_bps);
+}
+
+DataRate& DataRate::operator -= (DataRate rhs)
+{
+  NS_ASSERT_MSG(m_bps >= rhs.m_bps, "Data Rate cannot be negative.");
+  m_bps -= rhs.m_bps;
+  return *this;
+}
+
+DataRate DataRate::operator * (double rhs)
+{
+  return DataRate(((uint64_t)(m_bps * rhs)));
+}
+
+DataRate& DataRate::operator *= (double rhs)
+{
+  m_bps *= rhs;
+  return *this;
+}
+
+DataRate DataRate::operator * (uint64_t rhs)
+{
+  return DataRate(m_bps * rhs);
+}
+
+DataRate& DataRate::operator *= (uint64_t rhs)
+{
+  m_bps *= rhs;
+  return *this;
+}
+
 bool DataRate::operator < (const DataRate& rhs) const
 {
   return m_bps<rhs.m_bps;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/data-rate.h ns-3.34/src/network/utils/data-rate.h
--- ns-3.33/src/network/utils/data-rate.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/utils/data-rate.h	2021-07-14 10:31:07.000000000 -0700
@@ -119,6 +119,75 @@
   DataRate (std::string rate);
 
   /**
+   * \return the DataRate representing the sum of this object with rhs
+   * 
+   * \param rhs the DataRate to add to this DataRate
+   */
+  DataRate operator + (DataRate rhs);
+
+  /**
+   * \return the DataRate representing the sum of this object with rhs
+   * 
+   * \param rhs the DataRate to add to this DataRate
+   */
+  DataRate& operator += (DataRate rhs);
+
+  /**
+   * \return the DataRate representing the difference of this object with rhs
+   * 
+   * \param rhs the DataRate to subtract from this DataRate
+   */
+  DataRate operator - (DataRate rhs);
+
+  /**
+   * \return the DataRate representing the difference of this object with rhs
+   * 
+   * \param rhs the DataRate to subtract from this DataRate
+   */
+  DataRate& operator -= (DataRate rhs);
+
+  /**
+   * \brief Scales the DataRate
+   * 
+   * Multiplies with double and is re-casted to an int
+   * 
+   * \return DataRate object representing the product of this object with rhs 
+   * 
+   * \param rhs the double to multiply to this datarate
+   */
+  DataRate operator * (double rhs);
+
+  /**
+   * \brief Scales the DataRate
+   * 
+   * Multiplies with double and is re-casted to an int 
+   * 
+   * \return DataRate object representing the product of this object with rhs
+   * 
+   * \param rhs the double to multipy to this datarate
+   */
+  DataRate& operator *= (double rhs);
+
+  /**
+   * \brief Scales the DataRate
+   * 
+   * \return DataRate object representing the product of this object with rhs
+   * 
+   * \param rhs the uint64_t to multipy to this datarate
+   */
+  DataRate operator * (uint64_t rhs);
+
+  /**
+   * \brief Scales the DataRate
+   * 
+   * \return DataRate object representing the product of this object with rhs
+   * 
+   * \param rhs the uint64_t to multipy to this datarate
+   */
+  DataRate& operator *= (uint64_t rhs);
+
+
+  /**
    * \return true if this rate is less than rhs
    *
    * \param rhs the datarate to compare to this datarate
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/ipv4-address.cc ns-3.34/src/network/utils/ipv4-address.cc
--- ns-3.33/src/network/utils/ipv4-address.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/utils/ipv4-address.cc	2021-07-14 10:31:07.000000000 -0700
@@ -197,6 +197,10 @@
   return tmp; 
 }
 
+/**
+ *  Value of a not-yet-initialized IPv4 address, corresponding to 102.102.102.102.
+ *  This is totally arbitrary.
+ */
 static constexpr uint32_t UNINITIALIZED = 0x66666666U;
 
 Ipv4Address::Ipv4Address ()
@@ -422,7 +426,7 @@
 
 size_t Ipv4AddressHash::operator() (Ipv4Address const &x) const
 { 
-  return x.Get ();
+  return std::hash<uint32_t>()(x.Get ());
 }
 
 std::ostream& operator<< (std::ostream& os, Ipv4Address const& address)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/network/utils/ipv4-address.h ns-3.34/src/network/utils/ipv4-address.h
--- ns-3.33/src/network/utils/ipv4-address.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/network/utils/ipv4-address.h	2021-07-14 10:31:07.000000000 -0700
@@ -396,35 +396,16 @@
  */
 std::istream & operator >> (std::istream &is, Ipv4Mask &mask);
 
-/**
- * \brief Equal to operator.
- *
- * \param a the first operand
- * \param b the first operand
- * \returns true if the operands are equal
- */
 inline bool operator == (const Ipv4Address &a, const Ipv4Address &b)
 {
   return (a.m_address == b.m_address);
 }
-/**
- * \brief Not equal to operator.
- *
- * \param a the first operand
- * \param b the first operand
- * \returns true if the operands are not equal
- */
+
 inline bool operator != (const Ipv4Address &a, const Ipv4Address &b)
 {
   return (a.m_address != b.m_address);
 }
-/**
- * \brief Less than operator.
- *
- * \param a the first operand
- * \param b the first operand
- * \returns true if the operand a is less than operand b
- */
+
 inline bool operator < (const Ipv4Address &a, const Ipv4Address &b)
 {
   return (a.m_address < b.m_address);
@@ -435,35 +416,24 @@
  *
  * \brief Class providing an hash for IPv4 addresses
  */
-class Ipv4AddressHash : public std::unary_function<Ipv4Address, size_t> {
+class Ipv4AddressHash {
 public:
   /**
-   * Returns the hash of the address
+   * \brief Returns the hash of an IPv4 address.
    * \param x the address
    * \return the hash
+   *
+   * This method uses std::hash rather than class Hash
+   * as speed is more important than cryptographic robustness.
    */
   size_t operator() (Ipv4Address const &x) const;
 };
 
-/**
- * \brief Equal to operator.
- *
- * \param a the first operand
- * \param b the first operand
- * \returns true if the operands are equal
- */
 inline bool operator == (Ipv4Mask const &a, Ipv4Mask const &b)
 {
   return (a.m_mask == b.m_mask);
 }
 
-/**
- * \brief Not equal to operator.
- *
- * \param a the first operand
- * \param b the first operand
- * \returns true if the operands are not equal
- */
 inline bool operator != (Ipv4Mask const &a, Ipv4Mask const &b)
 {
   return (a.m_mask != b.m_mask);
